<?php
/**
 * @file lib.php
 * @author lacovnk
 * @brief library
 */
ini_set('display_errors','On');
error_reporting(E_ALL);
include_once './config.php';
include_once './dbconnect.php';
include_once './lib.class.php';
include_once './lib.data.php';

/// @brief query given string
function query($query)
{
	//echo "<pre>$query</pre>";
	return mysql_query($query);
}

////////////////////
// query - get
////////////////////

/// @brief query get time - all
function query_get_time_all(){return query("SELECT * FROM danawa_time ORDER BY timeDate ASC,timeOrder ASC");}

/// @brief query get time - by timeId
function query_get_time_by_id($timeId){return query("SELECT * FROM danawa_time WHERE timeId = '{$timeId}' ORDER BY timeDate ASC,timeOrder ASC");}

/// @brief query get time - by type, period
function query_get_time_by_type_period($type,$begin,$end)
{
    $where = array();
    if(check_yyyymmdd($begin) && check_yyyymmdd($end)){$where['period'] = "timeDate <= {$end} AND timeDate >= {$begin}";}
    if(check_timeType($type)){$where['type'] = "timeType = '{$type}'";}
    if(count($where) != 0){$where = 'WHERE '.implode(" AND ",$where);}
    else {$where = '';}
	return query("SELECT * FROM danawa_time $where ORDER BY timeDate ASC,timeOrder ASC");
}

/// @brief query get time - latest
function query_get_time_latest(){return query("SELECT * FROM danawa_time ORDER BY timeDate DESC LIMIT 0,1");}

/// @brief query get member - all
function query_get_member_all(){return query_get_member(NULL,NULL,NULL,NULL,NULL);}

/// @brief query get member - by memberId, part, active, regular, order
function query_get_member($memberId,$part,$active,$regular,$order)
{
    if($order==NULL){$order = 'memberPart ASC,memberName ASC';}
    $order = 'ORDER BY '.$order;

    $where = array();
    if($memberId != NULL){addArray($where,"memberId='{$memberId}'");}
    if($part == NULL || $part < -4 || $part > 8 || $part == '0'){;}
    else if($part < 0)
    {
        $part_1 = (-$part) * 2 - 1;
        $part_2 = $part_1 + 1;
        addArray($where,"(memberPart='{$part_1}' OR memberPart='{$part_2}')");
    }
    else {addArray($where,"(memberPart='{$part}')");}
    if($active == '1'){addArray($where,"(memberIsActive='1')");}
    else if($active == '2'){addArray($where,"(memberIsActive!='1')");}
    if($regular == '1'){addArray($where,"(memberIsRegular='1')");}
    else if($regular == '2'){addArray($where,"(memberIsRegular!='1')");}

    if(sizeof($where) !=0){$where = "WHERE ".implode(' AND ',$where);}
    else{$where = '';}
    return query("SELECT * FROM danawa_member $where $order");

}

/// @brief query get check - by memberId, type, period
function query_get_check_memberId_type_period($memberId,$type,$begin,$end)
{
	$where = array();
    if(check_yyyymmdd($begin) && check_yyyymmdd($end)){$where['period'] = "timeDate <= {$end} AND timeDate >= {$begin}";}
    if(check_timeType($type)){$where['type'] = "timeType = '{$type}'";}
    $where['default'] = "(memberId='{$memberId}' AND danawa_check.timeId=danawa_time.timeId)";
    if(count($where) != 0){$where = 'WHERE '.implode(" AND ",$where);}
    else {$where = '';}
	return query("SELECT * FROM danawa_check,danawa_time $where ORDER BY timeDate ASC,timeOrder ASC");

}

/// @brief query get check - by memberId
function query_get_check_by_memberId($memberId){return query("SELECT * FROM danawa_check,danawa_time WHERE danawa_check.memberId={$memberId} AND danawa_time.timeId=danawa_check.timeId ORDER BY danawa_time.timeDate ASC,danawa_time.timeID ASC");}

////////////////////
// query - update

////////////////////

/// @brief query update time
function query_update_time($timeId,$timeDate,$timeOrder,$timeType,$timeLength){query("UPDATE danawa_time SET timeDate='$timeDate',timeOrder='$timeOrder',timeType='$timeType',timeLength='$timeLength' WHERE timeId='$timeId'");}

/// @brief query update member
function query_update_member($memberId,$memberName,$memberPart,$memberNumberSchool,$memberIsActive,$memberIsRegular){query("UPDATE danawa_member SET memberName='$memberName',memberPart='$memberPart',memberNumberSchool='$memberNumberSchool',memberIsActive='$memberIsActive',memberIsRegular='$memberIsRegular' WHERE memberId='$memberId'");}

/// @brief query update check
function query_update_check($checkId,$checkResult){query("UPDATE danawa_check SET checkResult='$checkResult' WHERE checkId='$checkId'");}

////////////////////
// query - add

////////////////////

/// @brief query add time
function query_add_time($timeDate,$timeOrder,$timeType,$timeLength)
{
	query("INSERT INTO danawa_time (timeDate,timeOrder,timeType,timeLength) VALUES ('$timeDate','$timeOrder','$timeType','$timeLength')");
	$timeId = mysql_insert_id();

	$result_member = query_get_member_all();
	$num_result_member = mysql_num_rows($result_member);
	for($i=0;$i<$num_result_member;$i++)
	{
		$cur_member = mysql_fetch_array($result_member);
		query("INSERT INTO danawa_check (timeId,memberId) VALUES ('$timeId','{$cur_member['memberId']}')");
	}
}

/// @brief query add member
function query_add_member($memberName,$memberPart,$memberNumberSchool,$memberIsActive,$memberIsRegular)
{
	query("INSERT INTO danawa_member (memberName,memberPart,memberNumberSchool,memberIsActive,memberIsRegular) VALUES('$memberName','$memberPart','$memberNumberSchool','$memberIsActive','$memberIsRegular')");
	$memberId = mysql_insert_id();
	$result_time = query_get_time_all();
	$num_result_time = mysql_num_rows($result_time);
	for($i=0;$i<$num_result_time;$i++)
	{
		$cur_time = mysql_fetch_array($result_time);
		query("INSERT INTO danawa_check (timeId,memberId) VALUES ('{$cur_time['timeId']}','$memberId')");
	}

}

////////////////////
// query - delete

////////////////////

/// @brief query delete time
function query_delete_time($timeId)
{
	query("DELETE FROM danawa_time WHERE timeId='$timeId'");
	query("DELETE FROM danawa_check WHERE timeId='$timeId'");
}

/// @brief query delete member
function query_delete_member($memberId)
{
	query("DELETE FROM danawa_member WHERE memberId='$memberId'");
	query("DELETE FROM danawa_check WHERE memberId='$memberId'");
	
}

//////////
// Html Tag

//////////

/// @brief make HTML - table for edit
function makeHTML_Table_Edit(&$resource,$field_edit,$field_print)
{
	foreach($field_print as $cur){print "{$cur} {$resource[$cur]}<br><input type='hidden' name='{$cur}' value='{$resource[$cur]}' />";}
	foreach($field_edit as $cur)
	{
		print $cur;
		eval("makeHTML_Input_{$cur}('{$resource[$cur]}');");
		print '<br>';
	}
}

/// @brief make HTML - Input - general
function makeHTML_Input($type,$name,$value=null,$option=null){print "<input type=\"text\" name=\"$name\" id=\"$name\" value=\"$value\" $option />";}

/// @brief make HTML - Input - timeId
function makeHTML_Input_timeId(){print 'New';}

/// @brief make HTML - Input - timeType
function makeHTML_Input_timeType($timeType=0){global $data;makeHTML_Input_Select('timeType',$data['SelectTimeType'],$timeType);}

/// @brief make HTML - Input - timeLength
function makeHTML_Input_timeLength($timeLength=2){global $data;makeHTML_Input_Select('timeLength',$data['SelectTimeLength'],$timeLength);}

/// @brief make HTML - Input - timeDate
function makeHTML_Input_timeDate($timeDate=""){makeHTML_Input('text','timeDate',$timeDate);}

/// @brief make HTML - Input - timeOrder
function makeHTML_Input_timeOrder($timeOrder=""){global $data;makeHTML_Input_Select('timeOrder',$data['SelectTimeOrder'],$timeOrder);}

/// @brief make HTML - Input - memberId
function makeHTML_Input_memberId(){print 'New';}

/// @brief make HTML - Input - memberName
function makeHTML_Input_memberName($memberName=""){makeHTML_Input('text','memberName',$memberName);}

/// @brief make HTML - Input - memberPart
function makeHTML_Input_memberPart($memberPart=0){global $data;makeHTML_Input_Select('memberPart',$data['SelectPart'],$memberPart);}

/// @brief make HTML - Input - memberNumberSchool
function makeHTML_Input_memberNumberSchool($memberNumberSchool=DEFAULTNUMBERSCHOOL){makeHTML_Input('text','memberNumberSchool',$memberNumberSchool);}

/// @brief make HTML - Input - memberIsActive
function makeHTML_Input_memberIsActive($memberIsActive='1'){global $data;makeHTML_Input_Select('memberIsActive',$data['SelectActive'],$memberIsActive);}

/// @brief make HTML - Input - memberIsRegular
function makeHTML_Input_memberIsRegular($memberIsRegular='1'){global $data;makeHTML_Input_Select('memberIsRegular',$data['SelectRegular'],$memberIsRegular);}

function makeHTML_Input_memberStartDate($memberStartDate=NULL){global $data;makeHTML_Input_Select('memberStartDate',$data['SelectTimeId'],$memberStartDate);}

/// @brief make HTML - Input - select
function makeHTML_Input_Select($name,$options,$default=NULL)
{
	print "<select name='{$name}'>";
	foreach($options as $cur)
	{
		if($cur[0] == $default){print "<option value='{$cur[0]}' selected>{$cur[1]}</option>";}
		else {print "<option value='{$cur[0]}'>{$cur[1]}</option>";}
	}
	print '</select>';
}

/// @brief make HTML - Input - check
function makeHTML_Input_Check($boxId,$checkId,$code)
{
	echo("<img src=\"./images/$code.png\" id=\"i_$boxId\" alt=\"$code\" onclick=\"doChange(this)\" />");
	echo("<input type=\"hidden\" name=\"$boxId\" id = \"$boxId\" value=\"$checkId-$code\" />");
}

/// @brief make HTML - toggle - link
function makeHTML_toggleLink($text,$target){print "<a href='#' onclick='layer_toggle(\"$target\")'>{$text}</a>";}

/// @brief make HTML - toggle - open div
function makeHTML_toggleLayer_open($id){print "<div id='{$id}' style='display:none'>";}

/// @brief make HTML - toggle - close div
function makeHTML_toggleLayer_close($id){print '</div>';}

/// @brief make HTML - javascript - reload
function makeHTML_JS_reload($mesg='Change!')
{
	print <<<BUF
	<script type="text/javascript">
		alert('$mesg');
		parent.opener.location.reload();
		window.close();
	</script>
BUF;
}

/// @brief make HTML - javascript - move
function makeHTML_JS_goon($mesg='Change!')
{
	print <<<BUF
	<script type="text/javascript">
		alert('$mesg');
		location.href='{$_SERVER['HTTP_REFERER']}';
	</script>
BUF;
}

/// @brief make HTML - javascript - focus
function makeHTML_JS_focus($id){print "<script>document.getElementById('{$id}').focus();</script>";}

/// @brief make HTML - javascript - shortcut
function makeHTML_JS_key()
{
	print <<<BUF
<script type="text/javascript">
	_dom=0;
	strs='';
	function keypresshandler(e){
		if(document.all) e=window.event; // for IE
		if(_dom==3) var EventStatus = e.srcElement.tagName;
		else if(_dom==1) var EventStatus = e.target.nodeName; // for Mozilla

		if(EventStatus == 'INPUT' || EventStatus == 'TEXTAREA' || _dom == 2) return;

		var cc = '';
		var ch = '';

		if(_dom==3) { // for IE
			if(e.keyCode>0) {
				ch=String.fromCharCode(e.keyCode);
				cc=e.keyCode;
			}
		} else { // for Mozilla
			cc=(e.keyCode);
			if(e.charCode>0) {
				ch=String.fromCharCode(e.charCode);
			}
		}
		ch = ch.toLowerCase();
		var ob;
		switch(ch)
		{
			case 'q' : {ob = document.getElementById("02");break;}
			case 'w' : {ob = document.getElementById("01");break;}
			case 'e' : {ob = document.getElementById("00");break;}
			case 'a' : {ob = document.getElementById("12");break;}
			case 's' : {ob = document.getElementById("11");break;}
			case 'd' : {ob = document.getElementById("10");break;}
			case 'z' : {ob = document.getElementById("22");break;}
			case 'x' : {ob = document.getElementById("21");break;}
			case 'c' : {ob = document.getElementById("20");break;}
			case 'f' : {ob = document.getElementById("full");break;}
			case 'r' : {ob = document.getElementById("empty");break;}
			default : break;
		}
		if(ob != null){dothis(ob);}
	}
	function input(){
		_dom=document.all ? 3 : (document.getElementById ? 1 : (document.layers ? 2 : 0));
		document.onkeypress = keypresshandler;
	}
	input();
</script>
BUF;
}

/// @brief
function get_get_string_except($exceptArray,$array=NULL)
{
    $result = '';
    if($array == NULL){$array = $_GET;}
    $keys = array_keys($array);
    foreach($keys as $cur_key){if(false == in_array($cur_key,$exceptArray)){$result = $result."&amp;{$cur_key}={$array[$cur_key]}";}}
    if(strlen($result)>=4){$result = substr($result,5);}
    return $result;
}

/// @brief menu - active
function menu_select_active(&$active,$default)
{
    global $data;
    $active = getFromArray($_GET,'active',$default);
    $get_string = get_get_string_except(array('active'));
    if($active != '1' && $active != '2'){$active = '0';}
    print '<div>';
    for($i=0;$i<3;$i++)
    {
        if($i == "$active"){print "<strong>{$data['menuActive'][$i]}</strong>&nbsp;";}
        else{print "<a href='?{$get_string}&amp;active={$i}'>{$data['menuActive'][$i]}</a>&nbsp;";}
    }
    print '</div>';
}

/// @brief menu - regular
function menu_select_regular(&$regular,$default)
{
    global $data;
    $regular = getFromArray($_GET,'regular',$default);
    $get_string = get_get_string_except(array('regular'));
    if($regular != '1' && $regular != '2'){$regular = '0';}
    print '<div>';
    for($i=0;$i<3;$i++)
    {
        if($i == "$regular"){print "<strong>{$data['menuRegular'][$i]}</strong>&nbsp;";}
        else{print "<a href='?{$get_string}&amp;regular={$i}'>{$data['menuRegular'][$i]}</a>&nbsp;";}
    }
    print '</div>';
}

/// @brief menu - schoolNumber
function menu_select_schoolNumber(&$schoolNumber)
{
    global $data;
    $schoolNumber = getFromArray($_GET,'schoolNumber','1');
    $get_string = get_get_string_except(array('schoolNumber'));
    if($schoolNumber !='1' ){$schoolNumber = '0';}
    print '<div>';
    for($i=1;$i>=0;$i--)
    {
        if($i == "$schoolNumber"){print "<strong>{$data['menuSchoolNumber'][$i]}</strong>&nbsp;";}
        else{print "<a href='?{$get_string}&amp;schoolNumber={$i}'>{$data['menuSchoolNumber'][$i]}</a>&nbsp;";}
    }
    print '</div>';
}

/// @brief menu - part
function menu_select_part(&$part)
{
    global $data;
    $part = getFromArray($_GET,'part','0');
    $get_string = get_get_string_except(array('part'));

    print '<div>';
    if($part == '0'){print '<strong>All</strong>';}
    else {print "<a href='?{$get_string}'>All</a>";}
    for($i=1;$i<=4;$i++)
    {
        if($part == -$i){print "&nbsp;<strong>{$data['SeperatorPartSATB'][$i]}</strong>";}
        else {print "&nbsp;<a href='?{$get_string}&amp;part=-{$i}'>{$data['SeperatorPartSATB'][$i]}</a>";}
    }
    print '</div>';
}

/// @brief menu - type
function menu_select_type(&$type)
{
    global $data;
    $type = getFromArray($_GET,'type','');
    $get_string = get_get_string_except(array('type'));

    print '<div>';
    if($type == ''){print '<strong>All</strong>';}
    else {print "<a href='?{$get_string}'>All</a>";}
    for($i=0;$i<=1;$i++)
    {
        if($type == "$i"){print "&nbsp;<strong>{$data['NameTimeType'][$i]}</strong>";}
        else {print "&nbsp;<a href='?{$get_string}&amp;type={$i}'>{$data['NameTimeType'][$i]}</a>";}
    }
    print '</div>';
}

/// @brief menu - period
function menu_select_period(&$begin,&$end,$default_view,$default_begin=NULL,$default_end=NULL,$default_month=NULL)
{
	global $config;
	global $data;
    $self = substr($_SERVER['PHP_SELF'],1);
    $begin = getFromArray($_GET,'begin',$default_begin);
    $end = getFromArray($_GET,'end',$default_end);
    $month = getFromArray($_GET,'month',$default_month);
    $view = getFromArray($_GET,'view',$default_view);

    $get_string = get_get_string_except(array('view','begin','end','month'));
    print '<div>';
    foreach($data['menuView'] as $cur)
    {
	    if($cur[0] == $view){print "<strong>{$cur[1]}</strong>&nbsp;";}
	    else {print "<a href='?{$get_string}&amp;view={$cur[0]}'>{$cur[1]}</a>&nbsp;";}
    }
    print '</div>';
    switch($view)
    {
	    case 'month':
	    {
		    $month_lastest = get_month_lastest();
		    if($month == NULL){$month = $month_lastest;}
			set_period_by_month($begin,$end,$month);
			$get_string = get_get_string_except(array('month'));
			print '<div id="select_month">';
			for($i=$config['start_month'];$i<=$month_lastest;$i++)
			{
				if($i<10) {$month_now = '0'.$i;}
				else {$month_now = $i;}
				if($month_now == $month){print "<strong>{$i}월&nbsp;</strong>";}
				else {print "<a href='?{$get_string}&amp;month={$month_now}'>{$i}월</a>&nbsp;";}
			}
	print '</div>';
		    break;
	    }
	    case 'period':
	    {
		    if($begin == NULL){}
		    if($end == NULL){}
			$get_string = get_get_string_except(array('begin','end'));
			print <<<BUF
<div id='select_period'>
	<input type='hidden' id='get_string' value='{$get_string}' />
	<input type='hidden' id='self' value='{$self}' />
	<input type='text' id='begin' value='{$begin}' style='width:60px' /> ~ <input type='text' id='end' value='{$end}' style='width:60px' />
	&nbsp;<a href="#" onclick="period_go(this)">Go</a>
</div>
BUF;
		    break;
	    }
	    case 'all':
	    {
		    $begin = $config['year'].'0101';
		    $end = $config['year'].'1231';
	    }
	    default:
	    {
		    // ERROR!
		    break;
	    }
    }
}

/// @brief make Resource - member
function makeResource_member($part,$schoolNumber,$active,$regular,&$member)
{
    if($schoolNumber == '1'){$order = "memberPart ASC,memberNumberSchool ASC,memberName ASC";}
    else {$order = NULL;}
    $member = new Resource('member',query_get_member($memberId=NULL,$part,$active,$regular,$order));
}

/// @brief make Resource - time
function makeResource_time($begin,$end,$type,&$time)
{
    global $config;
    if(!check_mmdd($begin) || !check_mmdd($end)){}
    $time = new Resource('time',query_get_time_by_type_period($type,$begin,$end));
}

/// @brief seperator - schoolNumber
function seperator_schoolNumber($schoolNumber){return;}

/// @brief seperator - part
function seperator_part($part,$partSATB,$num_colspan)
{
	global $data;
    $get_string = get_get_string_except(array('part'));
	$part_name = $data['SelectPart'][$part-1][1];
	$part_class = $partSATB.(($part + 1)%2);
	print "<tr class='part{$part_class}'><td colspan='$num_colspan'><a href='?{$get_string}&amp;part={$part}'>$part_name</a></td></tr>\n";
}

/// @brief seperator - partSATB
function seperator_partSATB($partSATB,$num_colspan)
{
	global $data;
    $get_string = get_get_string_except(array('part'));
	print "<tr class='part{$partSATB}'><td colspan='$num_colspan'><a href='?{$get_string}&amp;part=-{$partSATB}'>{$data['SelectPartSATB'][$partSATB - 1][1]}</a></td></tr>\n";
}

//////////
// Helper Function

//////////

function checkCrack(){}

/// @brief get data from array, with default value
function getFromArray(&$array,$index,$default=''){if(array_key_exists($index,$array)){return $array[$index];}else{return $default;}}

/// @brief get parsed contents from file
function getParsedContentsAtFile($filename){ob_start();include($filename);$result=ob_get_contents();ob_end_clean();return $result;}

/// @brief get SATB number from Part number
function getSATBNumberFromPartNmber($partNumber){return floor(($partNumber + 1)/2);}

/// @brief get total time length from time Resource
function getTotalTimeLength($timeResource)
{
	$totalTime = array(0,0);
	for($i=0;$i<$timeResource->num_rows;$i++)
	{
		$cur_time = $timeResource->fetch_array();
		$totalTime[$cur_time['timeType']] += $cur_time['timeLength'];
	}
	return $totalTime;
}
function compare_by_rate($a,$b)
{
    if($a['rate'] == $b['rate']){return 0;}
    return ($a['rate'] > $b['rate'])? -1:1;
}
function compare_by_memberName($a,$b)
{
    if($a['memberName'] == $b['memberName']){return 0;}
    return ($a['memberName'] < $b['memberName'])? -1:1;
}
function getAttendenceOptionUabsence($typedArray,$include_uabsence)
{
	switch($include_uabsence)
	{
		case UABSENCE_SUBSTRACTTOTAL:
		case UABSENCE_LIKEABSENCE:return $typedArray['attendence'];
		case UABSENCE_ADDTOATTENDENCE:return $typedArray['attendence'] + $typedArray['uabsence'];
	}
}
function getTotalTimeLengthOptionUabsence($typedArray,$include_uabsence)
{
	switch($include_uabsence)
	{
		case UABSENCE_ADDTOATTENDENCE:
		case UABSENCE_LIKEABSENCE:return $typedArray['totalTimeLength'];
		case UABSENCE_SUBSTRACTTOTAL:return $typeArray['totalTimeLength'] - $typeArray['uabsence'];
	}
}

/// @brief get now MM
function get_month_now()
{
	$result = date('m');
	if($result < 10) {$result = '0'.$result;}
	return $result;
}

/// @brief get last time MM
function get_month_lastest()
{
	$latest_time = mysql_fetch_array(query_get_time_latest());
	return substr($latest_time['timeDate'],5,2);
}

/// @brief get period(YYYYMMDD) by MM
function set_period_by_month(&$begin, &$end, $month)
{
	global $config;
	$begin = $config['year'].$month.'01';
	$end = $config['year'].$month.'31';
}

/// @brief check string is MMDD
function check_mmdd($src)
{
    if(strlen($src) != 4){return false;}
    $mm = substr($src,0,2);
    if(!($mm <= 12 && $mm >= 1)){return false;}
    $dd = substr($src,2);
    if(!($dd <= 31 && $dd >= 1)){return false;}
    return true;
}

/// @brief check string is YYYYMMDD
function check_yyyymmdd($src)
{
    if(strlen($src) != 8){return false;}
    $mmdd = substr($src,4);
    return check_mmdd($mmdd);
}

/// @brief check type is existed
function check_timeType($type)
{
    global $data;
    return array_key_exists($type,$data['NameTimeType']);
}

/// @brief check part is correct
function check_part($part)
{
    return ($part >=-4 && $part <= 8);
}

/// @brief add data to array
function addArray(&$target,$content){$target[sizeof($target)] = $content;}

/// @brief short text for print_r in <pre></pre>
function printr($array)
{
	echo '<pre>';
	print_r($array);
	echo '</pre>';
}

/// @brief my sort function (by insertion sort) - usort doesn't stable! -o-
function my_sort(&$array,$functionName)
{
	$size = sizeof($array);
	for($i=0;$i<$size;$i++)
	{
		$min = $i;
		for($j=$i+1;$j<$size;$j++)
		{
			if(1 == eval("return $functionName(\$array[\$i],\$array[\$j]);"))
			{
				$temp = $array[$i];
				$array[$i] = $array[$j];
				$array[$j] = $temp;
			}
		}
	}
}
?>
